package x33eja.model;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

import javax.persistence.OneToMany;

@Entity
public class Department implements Serializable {

    /**
     * Pro ciselny klic pouzit automaticke generovani napr. sekvencemi tzn.
     * misto Auto, kdy se ponecha volba na databazi, zvolit GenerationType.SEQUENCE
     * a nasledne jeste definovat jmeno sekvence, jinak bude pouzita vychozi
     * - spolecna pro vsechny entity
     * @GeneratedValue(strategy=GenerationType.SEQUENCE)
     * @SequenceGenerator(sequenceName="seq_department")
     *
     * anotace Column je volitelna
     */

    @Id        
    @Column(name = "ID")
    @GeneratedValue(strategy=GenerationType.AUTO)
    private int deptId;

    private String name;

    /**
     * Povsimnete si, u ktere relace je v tomto pripade umisten cizi klic
     */
    @OneToMany(mappedBy="department")
    private List<Teacher> members;

    public int getDeptId () {
        return deptId;
    }

    public void setDeptId (int val) {
        this.deptId = val;
    }

    public String getName () {
        return name;
    }

    public void setName (String val) {
        this.name = val;
    }

    public List<Teacher> getMembers() {
        return members;
    }

    public void setMembers(List<Teacher> members) {
        this.members = members;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Department other = (Department) obj;
        if (this.deptId != other.deptId) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 41 * hash + this.deptId;
        return hash;
    }


    
}

